Summary: Libsafe: Protecting Critical Elements of Stacks
Name: libsafe
Version: 2.0
Release: 12_NetHeaven
Copyright: LGPL
Group: System/Utilities
#Source: http://www.research.avayalabs.com/project/libsafe/libsafe-%{version}-%{release}.tgz
Source: http://www.research.avayalabs.com/project/libsafe/libsafe-2.0-12.tgz
URL: http://www.research.avayalabs.com/project/libsafe/index.html
Vendor: Avaya Labs Research
Packager: Navjot Singh <singh@research.avayalabs.com>
Provides: libsafe.so.1.3

%description
The libsafe library protects a process against the exploitation of buffer
overflow vulnerabilities in process stacks. Libsafe works with any
existing pre-compiled executable and can be used transparently, even on a
system-wide basis. The method intercepts all calls to library functions
that are known to be vulnerable. A substitute version of the corresponding
function implements the original functionality, but in a manner that
ensures that any buffer overflows are contained within the current stack
frame. Libsafe has been shown to detect several known attacks and can
potentially prevent yet unknown attacks. Experiments indicate that the
performance overhead of libsafe is negligible.

If libsafe is compiled on a system with libprelude installed, libsafe will
additionally emit a stack overflow alert to the Prelude Manager.  For more
information about the Prelude Hybrid IDS, please see http://www.prelude-ids.org

%prep
#%setup -q -n libsafe-%{version}-%{release}
%setup -q -n libsafe-2.0-12

%build
make

%install
make install

%files
%doc README COPYING ChangeLog INSTALL doc exploits tools
#/lib/libsafe.so.%{version}.%{release}
/lib/libsafe.so.2.0.12

%clean 
rm -rf $RPM_BUILD_ROOT

%post
test -L /lib/libsafe.so.1.3 && rm -f /lib/libsafe.so.1.3
test ! -f /lib/libsafe.so.1.3 && ln -s /lib/libsafe.so.2.0.12 /lib/libsafe.so.1.3
/sbin/ldconfig
%preun
echo "Removing libsafe from /etc/ld.so.preload (if exists)"
if [ -f /etc/ld.so.preload ] ; then
  cp -fp /etc/ld.so.preload /etc/ld.so.preload.save
  grep -v libsafe /etc/ld.so.preload > /etc/ld.so.preload.tmp
  rm -f /etc/ld.so.preload
  if [ -s /etc/ld.so.preload.tmp ] ; then
    cp -fp /etc/ld.so.preload.tmp /etc/ld.so.preload
  fi
 rm -f /etc/ld.so.preload.tmp
fi

%postun
/sbin/ldconfig
test -L /lib/libsafe.so.1.3 && rm -f /lib/libsafe.so.1.3
